#include "Common.h"
#include "WorkerDefenceManager.h"


WorkerDefenceManager::WorkerDefenceManager()
{
	DefenceSCVS.clear();
}


void WorkerDefenceManager::OnFrame()
{
	BWAPI::Position CCpos = BWAPI::Position( InfoMan->OurBase );
	unsigned int getAWorker = 0;//Get the total amount of workers attacking us
	Unit* toAttack = NULL;
	BOOST_FOREACH(BWAPI::Unit*  enemy,  Broodwar->enemy()->getUnits() ) {
		if( enemy->getDistance( CCpos ) < 800 && CurrentStrategy != Wall_in && CurrentStrategy != One_Fact_3_Rax ){
			getAWorker++;
			toAttack = enemy;
		}
		if( CurrentStrategy == Wall_in  || CurrentStrategy == One_Fact_3_Rax ){
			//worker harass at the wall
		  if( enemy->getDistance( CCpos ) < 800 && enemy->getType().isWorker() ){
			getAWorker++;
			toAttack = enemy;
		  }
		  //wall breached
		  if( enemy->getDistance( CCpos ) < 400 && !enemy->getType().isWorker() ){
			getAWorker++;
			toAttack = enemy;
		  }
		  if( enemy->getDistance( CCpos ) < 800 && enemy->getType() == BWAPI::UnitTypes::Protoss_Photon_Cannon ){
			getAWorker+=5;
			toAttack = enemy;
		  }
		}
	}

	if( getAWorker > DefenceSCVS.size() ){
		//Broodwar->printf("Adding scv to defence");
		Unit* Dscvs = CCmanager[0]->getBuilder();
		if( Dscvs != NULL ){
		  if(  toAttack != NULL ){
			Dscvs->attack( toAttack );
		  }
		  AddSCV( Dscvs );
		}
	}

	if( getAWorker < DefenceSCVS.size() ){//once the defence is done, return scv to base
		while( getAWorker < DefenceSCVS.size() ){
			CCmanager[0]->addSCV( DefenceSCVS.back() );
			DefenceSCVS.pop_back();
			//Broodwar->printf("Returning scv to mining");
		}
	}

	for(unsigned int i=0; i<DefenceSCVS.size(); i++){
		if( !DefenceSCVS[i]->exists() ){ //dead scv
			DefenceSCVS.erase( DefenceSCVS.begin() + i );
			i--;
			continue;
		}
		if( toAttack != NULL ){
			if( DefenceSCVS[i]->getTarget() != NULL){
				//prevent spam attacking
				if( DefenceSCVS[i]->getTarget()->getID() != toAttack->getID()    ){
                  DefenceSCVS[i]->attack(toAttack);
				}
			} else {
		     DefenceSCVS[i]->attack(toAttack);
			}
		}
	}

}

void WorkerDefenceManager::AddSCV( BWAPI::Unit* scv )
{
	DefenceSCVS.push_back(scv);
}